#pragma once

#include <memory>
#include <vector>

#include "Socket.h"
#include "SocketInterface.h"

class NetworkManager
{
    std::vector<SocketPtr> mActiveSockets;
    SocketInterfaceUPtr mSocketInterface;

public:

    NetworkManager();

    ~NetworkManager();

    static std::unique_ptr<NetworkManager> Create();

    void Initialize();

    void OpenSocket(SocketPtr socket);

    void CloseSocket(SocketPtr socket);

    void RunHttpServer();

    void ShutDown();
};

using NetworkManagerUPtr = std::unique_ptr<NetworkManager>;
